"""
You are given list of numbers. Find the second largest number.

Input Format
List A that contains n numbers

Constraints
2 <= n <= 10
-100 <= A[i] <= 100

Output Format
Return the value of the second largest number. If the number does not exist,
return None

Sample Input 0
[2 3 6 6 5]

Sample of Returned Value 0
5

Explanation 0
Given list is [2, 3, 6, 6, 5]. The maximum number is 6, second maximum is 5.
Hence, we return 5 as our answer.

Note: Think about the time complexity of your solution.
"""


def second_largest(list):
    if len(list) == 0 or len(list) == 1 or min(list) == max(list):
        return None
    a = min(list)
    for i in list:
        if i > a and i != max(list):
            a = i
    return a


########################################################################
#               Tests                                                  #
########################################################################

ib113_inputs = [[],
                [2],
                [2, 2, 2],
                [2, 3],
                [2, 3, 3],
                [2, 3, 6, 6, 5],
                [1, 1, 0, 1, 1, 2],
                [0, 0, 0, -1],
                [0, 1, 1, 1, -1]
                ]

ib113_outputs = [None, None, None, 2, 2, 5, 1, -1, 0]


def ib113_test_second_largest():
    count = 0
    length = len(ib113_inputs)

    for i in range(length):
        res = second_largest(ib113_inputs[i])

        if res is None:
            if ib113_outputs[i] is not None:
                count += 1
        elif not isinstance(res, int) or res != ib113_outputs[i]:
            count += 1

    if count == 0:
        print("OK. All tests passed.")
    else:
        print("Wrong answer. Only %d / %d of tests passed." %
              (length - count, length))


if __name__ == '__main__':
    ib113_test_second_largest()
