# ################################## HW4 ################################## #
"""
Pokyny:
- Deadline odevzdani: 23. 11. 23:59
- Odevzdejte jediny soubor
    - Student - IB113 - Odevzdavarny - Skupina 01 (pripadne 02) - DU 4
- Muzete si vytvaret pomocne funkce, pokud chcete.
    - V teto uloze to je doporuceno
- V pripade, ze chcete vytvaret vlastni testy, vkladete je na prislusne misto
    na konci souboru.
    - Pred odevzdanim vlastni modifikace smazte.
- Piste srozumitelny kod, pouzivejte vhodne nazvy promennych a funkci.
- Dodrzujte standard pep8.
    - Budu kontrolovat a strhavat body za jeho nedodrzeni.
- Nemente hlavicky pripravenych funkci.
- Pripadne nejasnosti muzete resit v diskuznim foru. Pokud by ale mela otazka
    obsahovat kusy kodu, nebo neco, co by mohli ostatni studenti opsat, tak
    napiste radeji email.
- Pokud nevite, jak nejaky priklad vyresit kompletne, napiste do komentare,
    co vasemu reseni chybi.
- Neopisujte. Nestoji to za to. Dostanete zaporne body a budete muset ulohu
    stejne vypracovat sami.

Zadani:
Vytvorte program hrajici hru "Padajici piskvorky" uzivatele proti pocitaci
(na planu zadane velikosti). Tato variace piskvorek se hraje na dvourozmernem
hracim planu. Hra je podobna klasickym piskvorkam s tim rozdilem, ze pokud
jste na tahu, nevolite konkretni ctverecek, do ktereho byste umistili svuj
symbol, ale sloupec. Symbol v danem sloupci spadne dolu (nejvice, co to jde).
Vyhrava ten, kdo posklada 4 sve symboly v rade, sloupci nebo diagonale.

Zadani:
Vasim ukolem je implementovat:
1) Funkci show_state(state), ktera vypise dany plan na standardni vystup.
Plan je reprezentovan seznamem seznamu stejne delky, ktere obsahuji znaky
X (krizek), O (kolecko) nebo mezera pro neobsazene pole.
>> state = [[' ', ' ', ' ', ' ', ' '], [' ', ' ', ' ', ' ', 'O'],
         [' ', ' ', ' ', ' ', 'X'], [' ', 'O', ' ', ' ', 'X']]
>> show_state(state)

        O
        X
  O     X
- - - - -
0 1 2 3 4

2) Funkci strategy(state, symbol), ktera pro dany plan a symbol vrati pozici
(sloupec) tahu pocitace. Neni nutne aby byla nejak sofistikovana, muze
vracet nahodny sloupec v danem rozsahu.

>> state = [[' ', ' ', ' ', ' ', ' '], [' ', ' ', ' ', ' ', ' '],
            [' ', ' ', ' ', ' ', ' '], [' ', ' ', ' ', 'X', ' ']]
>> strategy(state, 'O')
2

3) Funkci tictactoe(rows, cols, human_starts=True), ktera umoznuje hrat hru
padajicich piskvorek na planu o danem poctu radku a sloupcu. Muzete
predpokladat, ze zadana velikost planu je rozumna (alespon 4 a mene nez 26
sloupcu a radku). Parametr human_starts urcuje, zda zacina hrac nebo pocitac.
Vypis prubehu hry by mel vypadat stejne, jako v nasledujicich prikladech.
Funkce kontroluje, zda jsou tahy zadane hracem a pocitacem platne a pokud
nejsou, vyzve ho k novemu zadani. Pro hru pocitace volejte vyse uvedene
funkce show_state(state) a strategy(state, symbol). Nezapomente, ze hra muze
skoncit i remizou

Priklad hry, v nemz zacina hrac:

Na tahu je hrac
Do jakeho sloupce chces hrat? (do 0 do 9)? 5

          X
- - - - - - - - - -
0 1 2 3 4 5 6 7 8 9

Na tahu je pocitac
Pocitac hraje do sloupce cislo 9

          X       O
- - - - - - - - - -
0 1 2 3 4 5 6 7 8 9

Na tahu je hrac
Do jakeho sloupce chces hrat? (do 0 do 9)? 6

          X X     O
- - - - - - - - - -
0 1 2 3 4 5 6 7 8 9

Na tahu je pocitac
Pocitac hraje do sloupce cislo 5

          O
          X X     O
- - - - - - - - - -
0 1 2 3 4 5 6 7 8 9

Na tahu je hrac
Do jakeho sloupce chces hrat? (do 0 do 9)? 4

          O
        X X X     O
- - - - - - - - - -
0 1 2 3 4 5 6 7 8 9

Na tahu je pocitac
Pocitac hraje do sloupce cislo 7

          O
        X X X O   O
- - - - - - - - - -
0 1 2 3 4 5 6 7 8 9

Na tahu je hrac
Do jakeho sloupce chces hrat? (do 0 do 9)? 3

          O
      X X X X O   O
- - - - - - - - - -
0 1 2 3 4 5 6 7 8 9
Vyhral jsi!

Bodovani:
- Funkce tictactoe(rows, cols, human_starts=True) musi korektne provadet hru
    hrace a pocitace, kontrolovat zadane tahy hrace a urcit vyhru. Vypis se
    musi shodovat s vyse uvedenymi ukazkami.
- Zakladni variantou strategy je funkce, ktera dodrzuje pravidla, ale jinak
    hraje nahodne. Pokud vas program bude hrat "inteligentne" (napriklad ukonci
    hru, pokud bude mit moznost), ziskate bonusove body. Cim inteligentneji,
    tim vice bodu. V kazdem pripade napiste do komentare strucne vysvetleni,
    jak moc inteligentne program hraje. Kvalita tohoto popisu je take dulezita.

Nekolik tipu:
- Nez zacnete psat kod, rozmyslete si (nejlepe si i nakreslete) dekompozici
    problemu na jednodussi funkce. Jinak se v tom ztratite. Problem lze
    rozlozit ruzne, priklady uzitecnych funkci: is_won(state) nebo
    valid_move(move, state), ale v prubehu reseni by vas pak mely napadnout
    jeste dalsi. Kdykoliv zjistite, ze mate v programu duplicitni kod,
    zbavte se ho (napr. prave pomoci nove pomocne funkce). A vsechny funkce
    by mely zustat dostatecne kratke a prehledne.
- Zacnete variantou s nahodnymi tahy, rozumne chovani pridejte az potom.
    Pri dobre dekompozici by rozsirovani nemel byt problem.
- Zkuste si tuto hru parkrat zahrat (s nekym nebo i sami se sebou), pomuze
    vam to lepe pochopit, jak by mel pocitac optimalne hrat.
"""

from random import randint


# Funkce vypise dany plan na standardni vystup. Plan je reprezentovan seznamem
#  seznamu stejne delky, ktere obsahuji znaky X (krizek), O (kolecko) nebo
#  mezera pro neobsazene pole.

# :param state:  Sezname seznamu obsahujici znaky X, 0, a mezera
def show_state(state):
    for i in range(len(state)):
        string = ' '
        for n in range(len(state[i])):
            string += state[i][n] + '  '
        print(string)
    print(' - ' * len(state[0]))
    string = ' '
    for i in range(len(state[0])):
        string += str(i + 1) + '  '
    print(string)


# Funkce pro dany plan state a symbol chr vrati pozici (sloupec) tahu
# pocitace.

#    :param state:  Sezname seznamu obsahujici znaky X, 0, a mezera
#    :param chr:    Znak, ktery se ma vlozit
#    :return:       Sloupec, do ktereho se ma vlozit znak chr
def strategy(cols):  # $ EMPTY 0
    return randint(1, cols)


# Funkce umoznuje hrat hru padajicich piskvorek na planu o danem poctu radku
# a sloupcu.

#   :param rows:    Pocet radku (4..25)
#   :param cols:    Pocet sloupcu (4..25)
#   :param human_starts: True, pokud zacina hrac, False jinak
def tictactoe(rows, cols, human_starts=True):
    print('### FALLING TICTACTOE ###')
    player = input('Do you want "x" or "o":')
    if player == 'x' or player == 'X':
        player = 'x'
        comp = 'o'
    elif player == 'o' or player == 'O' or player == '0':
        player = 'o'
        comp = 'x'
    else:
        print('Wrong input. Your symbol is "x".')
        player = 'x'
        comp = 'o'
    state = []
    for i in range(rows):
        state.append([' '] * cols)
    count = 0
    while True:
        show_state(state)
        if human_starts:
            my_choice = int(input('Your choice:'))
            symbol = player
        else:
            my_choice = strategy(cols)
            symbol = comp
            print("Computer's choice:", my_choice)
        for i in range(rows):
            if my_choice > cols:
                print('Wrong input.')
                human_starts = change(human_starts)
                break
            elif state[-i - 1][my_choice - 1] == ' ':
                state[-i - 1][my_choice - 1] = symbol
                count += 1
                break
            elif state[0][my_choice - 1] != ' ':
                print('This column is full.')
                human_starts = change(human_starts)
                break
        human_starts = change(human_starts)
        if is_won(state, count) == player:
            show_state(state)
            print('You won!')
            break
        elif is_won(state, count) == comp:
            show_state(state)
            print('You lost.')
            break
        elif is_won(state, count) == ' ':
            show_state(state)
            print('Draw.')
            break


def change(human_starts):
    if human_starts:
        return False
    else:
        return True


def is_won(state, count):
    if count == len(state) * len(state[0]):
        return ' '
    for i in range(len(state)):
        for n in range(3, len(state[0])):
            if state[i][n - 3] == state[i][n - 2] == state[i][n - 1] == \
                    state[i][n] == 'x':
                return 'x'
            elif state[i][n - 3] == state[i][n - 2] == state[i][n - 1] == \
                    state[i][n] == 'o':
                return 'o'
    for i in range(len(state[0])):
        for n in range(3, len(state)):
            if state[n - 3][i] == state[n - 2][i] == state[n - 1][i] == \
                    state[n][i] == 'x':
                return 'x'
            elif state[n - 3][i] == state[n - 2][i] == state[n - 1][i]\
                    == state[n][i] == 'o':
                return 'o'
    for i in range(3, len(state)):
        for n in range(3, len(state[0])):
            if state[i][n - 3] == state[i - 1][n - 2] == \
                    state[i - 2][n - 1] == state[i - 3][n] == 'x':
                return 'x'
            elif state[i - 3][n - 3] == state[i - 2][n - 2] == \
                    state[i - 1][n - 1] == state[i][n] == 'x':
                return 'x'
            elif state[i][n - 3] == state[i - 1][n - 2] == \
                    state[i - 2][n - 1] == state[i - 3][n] == 'o':
                return 'o'
            elif state[i - 3][n - 3] == state[i - 2][n - 2] == \
                    state[i - 1][n - 1] == state[i][n] == 'o':
                return 'o'


########################################################################
#               Nasleduje kod testu                                    #
########################################################################

# Zde muzete vkladat vlastni testy
if __name__ == '__main__':
    tictactoe(6, 6)
    pass
